Description

On defining my own DSL, | wanted to write a code like:

foo (Integer (ENV['FOO']) rescue nil)

where foo is a method which receives one argument , but | got following error

SyntaxError: (irb):1: syntax error, unexpected modifier_rescue, expecting ')'
In contrast, following codes were valid:

foo ((Integer (ENV['FOO']) rescue nil))

or

foo (begin; Integer (ENV['FOO']); rescue; nil; end)

This is a feature request to allow such a syntax, a postposed rescue in a method argument.

Associated revisions

Revision ec8f8fa4dc803ab9e71d1b38f5c0e32a3d2ffe0a9 - 08/19/2016 02:39 AM - nobu (Nobuyoshi Nakada)

parse.y: Iparen_arg statement

e parse.y (primary): allow parenthesised statement as a method
argument. [Feature #12686]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@55965 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision ec8f8fa4 - 08/19/2016 02:39 AM - nobu (Nobuyoshi Nakada)
parse.y: Iparen_arg statement

e parse.y (primary): allow parenthesised statement as a method
argument. [Feature #12686]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@55965 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 08/18/2016 06:00 AM - nobu (Nobuyoshi Nakada)

It sounds nothing wrong with it, to me.

diff --git i/parse.y w/parse.y
index 17f0£f9c..7al14941 100644
-—— i/parse.y
+++ w/parse.y
@@ -2659,7 +2659,7 @Q@ primary : literal
$<val>1l = cmdarg_stack;
CMDARG_SET (0) ;
}
= expr {SET_LEX_STATE (EXPR_ENDARG) ;} rparen
+ stmt {SET_LEX_STATE (EXPR_ENDARG) ; } rparen
{
CMDARG_SET ($<val>1);
/*%%%*/
diff --git i/test/ruby/test_syntax.rb w/test/ruby/test_syntax.rb
index ce01358..9b5b9f1 100644
——— 1i/test/ruby/test_syntax.rb
+++ w/test/ruby/test_syntax.rb
@@ -827,6 +827,10 Q@
end
end

+ def test_stmt_lparen_arg
+ assert_valid_syntax ("foo (bar rescue nil)")
+ end
L
private
def not_label (x) @result = x; @not_label ||= nil end

#2 - 08/18/2016 06:22 AM - nobu (Nobuyoshi Nakada)

https://github.com/ruby/ruby/compare/trunk...nobu:feature/12686-lparen_arg-stmt

#3 - 08/18/2016 08:10 AM - nobu (Nobuyoshi Nakada)

tLPAREN_ARG has been introduced at 1.7, | think we can clear up spaces and parentheses rules now.

#4 - 08/19/2016 02:39 AM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Closed

Applied in changeset r55965.

parse.y: Iparen_arg statement

e parse.y (primary): allow parenthesised statement as a method
argument. [Feature #12686]
